/*
Viral Loops v1

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package vloopapi

import (
	"encoding/json"
	"time"
)

// checks if the Referral type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Referral{}

// Referral User who shares his referral link for specific viral loop
type Referral struct {
	Id string `json:"id"`
	ViralLoopId string `json:"viral_loop_id"`
	ContactId string `json:"contact_id"`
	ConversationId string `json:"conversation_id"`
	ChannelId string `json:"channel_id"`
	CompletedMilestones []CompletedMilestone `json:"completed_milestones,omitempty"`
	CreatedFriends []Friend `json:"created_friends,omitempty"`
	CompletedFriends []Friend `json:"completed_friends,omitempty"`
	Rewards []Reward `json:"rewards,omitempty"`
	ReferralLink string `json:"referral_link"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
	Attributes *map[string]string `json:"attributes,omitempty"`
	Name string `json:"name"`
	TransactionId string `json:"transaction_id"`
	OrganizationId string `json:"organization_id"`
	GatewayMessengerId string `json:"gateway_messenger_id"`
	GatewayMessengerType string `json:"gateway_messenger_type"`
	Email *string `json:"email,omitempty"`
	MessengerId string `json:"messenger_id"`
	ForceNewLink bool `json:"force_new_link"`
}

// NewReferral instantiates a new Referral object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewReferral(id string, viralLoopId string, contactId string, conversationId string, channelId string, referralLink string, createdAt time.Time, updatedAt time.Time, name string, transactionId string, organizationId string, gatewayMessengerId string, gatewayMessengerType string, messengerId string, forceNewLink bool) *Referral {
	this := Referral{}
	this.Id = id
	this.ViralLoopId = viralLoopId
	this.ContactId = contactId
	this.ConversationId = conversationId
	this.ChannelId = channelId
	this.ReferralLink = referralLink
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	this.Name = name
	this.TransactionId = transactionId
	this.OrganizationId = organizationId
	this.GatewayMessengerId = gatewayMessengerId
	this.GatewayMessengerType = gatewayMessengerType
	this.MessengerId = messengerId
	this.ForceNewLink = forceNewLink
	return &this
}

// NewReferralWithDefaults instantiates a new Referral object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewReferralWithDefaults() *Referral {
	this := Referral{}
	return &this
}

// GetId returns the Id field value
func (o *Referral) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Referral) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Referral) SetId(v string) {
	o.Id = v
}

// GetViralLoopId returns the ViralLoopId field value
func (o *Referral) GetViralLoopId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ViralLoopId
}

// GetViralLoopIdOk returns a tuple with the ViralLoopId field value
// and a boolean to check if the value has been set.
func (o *Referral) GetViralLoopIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ViralLoopId, true
}

// SetViralLoopId sets field value
func (o *Referral) SetViralLoopId(v string) {
	o.ViralLoopId = v
}

// GetContactId returns the ContactId field value
func (o *Referral) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *Referral) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *Referral) SetContactId(v string) {
	o.ContactId = v
}

// GetConversationId returns the ConversationId field value
func (o *Referral) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *Referral) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *Referral) SetConversationId(v string) {
	o.ConversationId = v
}

// GetChannelId returns the ChannelId field value
func (o *Referral) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *Referral) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *Referral) SetChannelId(v string) {
	o.ChannelId = v
}

// GetCompletedMilestones returns the CompletedMilestones field value if set, zero value otherwise.
func (o *Referral) GetCompletedMilestones() []CompletedMilestone {
	if o == nil || IsNil(o.CompletedMilestones) {
		var ret []CompletedMilestone
		return ret
	}
	return o.CompletedMilestones
}

// GetCompletedMilestonesOk returns a tuple with the CompletedMilestones field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Referral) GetCompletedMilestonesOk() ([]CompletedMilestone, bool) {
	if o == nil || IsNil(o.CompletedMilestones) {
		return nil, false
	}
	return o.CompletedMilestones, true
}

// HasCompletedMilestones returns a boolean if a field has been set.
func (o *Referral) HasCompletedMilestones() bool {
	if o != nil && !IsNil(o.CompletedMilestones) {
		return true
	}

	return false
}

// SetCompletedMilestones gets a reference to the given []CompletedMilestone and assigns it to the CompletedMilestones field.
func (o *Referral) SetCompletedMilestones(v []CompletedMilestone) {
	o.CompletedMilestones = v
}

// GetCreatedFriends returns the CreatedFriends field value if set, zero value otherwise.
func (o *Referral) GetCreatedFriends() []Friend {
	if o == nil || IsNil(o.CreatedFriends) {
		var ret []Friend
		return ret
	}
	return o.CreatedFriends
}

// GetCreatedFriendsOk returns a tuple with the CreatedFriends field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Referral) GetCreatedFriendsOk() ([]Friend, bool) {
	if o == nil || IsNil(o.CreatedFriends) {
		return nil, false
	}
	return o.CreatedFriends, true
}

// HasCreatedFriends returns a boolean if a field has been set.
func (o *Referral) HasCreatedFriends() bool {
	if o != nil && !IsNil(o.CreatedFriends) {
		return true
	}

	return false
}

// SetCreatedFriends gets a reference to the given []Friend and assigns it to the CreatedFriends field.
func (o *Referral) SetCreatedFriends(v []Friend) {
	o.CreatedFriends = v
}

// GetCompletedFriends returns the CompletedFriends field value if set, zero value otherwise.
func (o *Referral) GetCompletedFriends() []Friend {
	if o == nil || IsNil(o.CompletedFriends) {
		var ret []Friend
		return ret
	}
	return o.CompletedFriends
}

// GetCompletedFriendsOk returns a tuple with the CompletedFriends field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Referral) GetCompletedFriendsOk() ([]Friend, bool) {
	if o == nil || IsNil(o.CompletedFriends) {
		return nil, false
	}
	return o.CompletedFriends, true
}

// HasCompletedFriends returns a boolean if a field has been set.
func (o *Referral) HasCompletedFriends() bool {
	if o != nil && !IsNil(o.CompletedFriends) {
		return true
	}

	return false
}

// SetCompletedFriends gets a reference to the given []Friend and assigns it to the CompletedFriends field.
func (o *Referral) SetCompletedFriends(v []Friend) {
	o.CompletedFriends = v
}

// GetRewards returns the Rewards field value if set, zero value otherwise.
func (o *Referral) GetRewards() []Reward {
	if o == nil || IsNil(o.Rewards) {
		var ret []Reward
		return ret
	}
	return o.Rewards
}

// GetRewardsOk returns a tuple with the Rewards field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Referral) GetRewardsOk() ([]Reward, bool) {
	if o == nil || IsNil(o.Rewards) {
		return nil, false
	}
	return o.Rewards, true
}

// HasRewards returns a boolean if a field has been set.
func (o *Referral) HasRewards() bool {
	if o != nil && !IsNil(o.Rewards) {
		return true
	}

	return false
}

// SetRewards gets a reference to the given []Reward and assigns it to the Rewards field.
func (o *Referral) SetRewards(v []Reward) {
	o.Rewards = v
}

// GetReferralLink returns the ReferralLink field value
func (o *Referral) GetReferralLink() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ReferralLink
}

// GetReferralLinkOk returns a tuple with the ReferralLink field value
// and a boolean to check if the value has been set.
func (o *Referral) GetReferralLinkOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ReferralLink, true
}

// SetReferralLink sets field value
func (o *Referral) SetReferralLink(v string) {
	o.ReferralLink = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *Referral) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *Referral) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *Referral) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *Referral) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *Referral) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *Referral) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *Referral) GetAttributes() map[string]string {
	if o == nil || IsNil(o.Attributes) {
		var ret map[string]string
		return ret
	}
	return *o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Referral) GetAttributesOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.Attributes) {
		return nil, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *Referral) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given map[string]string and assigns it to the Attributes field.
func (o *Referral) SetAttributes(v map[string]string) {
	o.Attributes = &v
}

// GetName returns the Name field value
func (o *Referral) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *Referral) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *Referral) SetName(v string) {
	o.Name = v
}

// GetTransactionId returns the TransactionId field value
func (o *Referral) GetTransactionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
func (o *Referral) GetTransactionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *Referral) SetTransactionId(v string) {
	o.TransactionId = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *Referral) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *Referral) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *Referral) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetGatewayMessengerId returns the GatewayMessengerId field value
func (o *Referral) GetGatewayMessengerId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.GatewayMessengerId
}

// GetGatewayMessengerIdOk returns a tuple with the GatewayMessengerId field value
// and a boolean to check if the value has been set.
func (o *Referral) GetGatewayMessengerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.GatewayMessengerId, true
}

// SetGatewayMessengerId sets field value
func (o *Referral) SetGatewayMessengerId(v string) {
	o.GatewayMessengerId = v
}

// GetGatewayMessengerType returns the GatewayMessengerType field value
func (o *Referral) GetGatewayMessengerType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.GatewayMessengerType
}

// GetGatewayMessengerTypeOk returns a tuple with the GatewayMessengerType field value
// and a boolean to check if the value has been set.
func (o *Referral) GetGatewayMessengerTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.GatewayMessengerType, true
}

// SetGatewayMessengerType sets field value
func (o *Referral) SetGatewayMessengerType(v string) {
	o.GatewayMessengerType = v
}

// GetEmail returns the Email field value if set, zero value otherwise.
func (o *Referral) GetEmail() string {
	if o == nil || IsNil(o.Email) {
		var ret string
		return ret
	}
	return *o.Email
}

// GetEmailOk returns a tuple with the Email field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Referral) GetEmailOk() (*string, bool) {
	if o == nil || IsNil(o.Email) {
		return nil, false
	}
	return o.Email, true
}

// HasEmail returns a boolean if a field has been set.
func (o *Referral) HasEmail() bool {
	if o != nil && !IsNil(o.Email) {
		return true
	}

	return false
}

// SetEmail gets a reference to the given string and assigns it to the Email field.
func (o *Referral) SetEmail(v string) {
	o.Email = &v
}

// GetMessengerId returns the MessengerId field value
func (o *Referral) GetMessengerId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MessengerId
}

// GetMessengerIdOk returns a tuple with the MessengerId field value
// and a boolean to check if the value has been set.
func (o *Referral) GetMessengerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MessengerId, true
}

// SetMessengerId sets field value
func (o *Referral) SetMessengerId(v string) {
	o.MessengerId = v
}

// GetForceNewLink returns the ForceNewLink field value
func (o *Referral) GetForceNewLink() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.ForceNewLink
}

// GetForceNewLinkOk returns a tuple with the ForceNewLink field value
// and a boolean to check if the value has been set.
func (o *Referral) GetForceNewLinkOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ForceNewLink, true
}

// SetForceNewLink sets field value
func (o *Referral) SetForceNewLink(v bool) {
	o.ForceNewLink = v
}

func (o Referral) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Referral) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["viral_loop_id"] = o.ViralLoopId
	toSerialize["contact_id"] = o.ContactId
	toSerialize["conversation_id"] = o.ConversationId
	toSerialize["channel_id"] = o.ChannelId
	if !IsNil(o.CompletedMilestones) {
		toSerialize["completed_milestones"] = o.CompletedMilestones
	}
	if !IsNil(o.CreatedFriends) {
		toSerialize["created_friends"] = o.CreatedFriends
	}
	if !IsNil(o.CompletedFriends) {
		toSerialize["completed_friends"] = o.CompletedFriends
	}
	if !IsNil(o.Rewards) {
		toSerialize["rewards"] = o.Rewards
	}
	toSerialize["referral_link"] = o.ReferralLink
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	toSerialize["name"] = o.Name
	toSerialize["transaction_id"] = o.TransactionId
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["gateway_messenger_id"] = o.GatewayMessengerId
	toSerialize["gateway_messenger_type"] = o.GatewayMessengerType
	if !IsNil(o.Email) {
		toSerialize["email"] = o.Email
	}
	toSerialize["messenger_id"] = o.MessengerId
	toSerialize["force_new_link"] = o.ForceNewLink
	return toSerialize, nil
}

type NullableReferral struct {
	value *Referral
	isSet bool
}

func (v NullableReferral) Get() *Referral {
	return v.value
}

func (v *NullableReferral) Set(val *Referral) {
	v.value = val
	v.isSet = true
}

func (v NullableReferral) IsSet() bool {
	return v.isSet
}

func (v *NullableReferral) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReferral(val *Referral) *NullableReferral {
	return &NullableReferral{value: val, isSet: true}
}

func (v NullableReferral) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReferral) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


